 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
           "http://www.w3.org/TR/REC-html40/loose.dtd">
 <HTML>

 <HEAD>
 <TITLE>JFLA 2000</TITLE>
 </HEAD>

 <BODY BGCOLOR="#FFFFFF">

 <H1 ALIGN=CENTER>JFLA 2000: relecture du papier 13</H1>

 <P>Numero du papier: 13
 <P>Titre du papier: Une plate forme logique de spécification et de
 preuve de programmes ML
 <P>Auteurs: Sylvain Baro

 <P>Nom du rapporteur: Emmanuel Ledinot

 <P>Confiance en la note:2
 <!-- 2 : j'ai compris, mais je ne domine pas le sujet.
     -->

 <P>Notation du papier: 3 
 <!-- 3 : acceptable;
     -->

 <P>Commentaires aux auteurs:<P>

      Le papier est rédigé souvent au futur et au conditionnel. Il s'en
dégage l'impression qu'il s'agit plus d'un programme de travail (bien
cadré) et d'une spécification d'outil
      que d'un papier décrivant une plate forme réalisée:
                    ." il sera possible de définir des fonctions
récursives avec filtrage ..."
                    . " le langage de spécification sera les formules du
calcul des prédicats du 1er ordre ..."
                    . " le langage de preuve sera ..."
      Il serait préférable de bien faire la part des choses;
       1.  soit annoncer que le papier pose le cadre théorique d'un
système de preuve qui reste `a réaliser, l'intéret du papier étant de
démontrer la bonne fondaison du système envisagé (votre section 4) avant

            sa réalisation, dans une perspective vision à terminaison.
       2.  soit annoncer que le papier décrit formellement un système de
preuve implanté et testé, mais alors l'honneteté impose de se limiter
dans la section 2 à la présentation de ce qui a été
            effectivement réalisé, et de reporter dans une section
"Perspectives" ce qui reste à faire.

      Il semble que ce soit plus l'option 1 que l'option 2, mais comme
il est affiché un objectif pratique de preuve effective de programmes ML
par des utilisateurs et qu'il semble implicitement
      qu'un début d'implémentation existe, on ne sait pas trop en
fonction de quels crit`eres évaluer votre papier. Dans le premier cas il
faut juger l'originalité, la difficulté, la solidité du travail
théorique
      réalisé conduisant aux propositions 5 et 7.

      Dans le second, on va plutôt juger l'intérêt pour un utilisateur,
en comparant par rapport à d'autres systèmes. La valeur ajoutée visée,
est m'a t'il semblé, la simplicité pour l'utilisateur. Dans
      l'introduction de votre section 2 vous écrivez (sic):
        "Le but de ces travaux est de développer un système d'aide à la
preuve qui soit utilisable par des personnes ayant l'habitude de
programmer, mais pas forcément classique minimale de logique".
      Si on remplace par "n'ayant pas forcément des connaissances
classiques minimales de logique", on croit comprendre que vous ciblez
des ingénieurs et non des chercheurs.

      A cet égard je partage totalement votre point de vue selon lequel
la preuve de programme est plus facile que la programmation par preuve.
      Par contre je ne partage pas (en tant qu'utilisateur d'un système
reposant sur une logique d'ordre supérieur) l'opinion selon laquelle
l'ordre supérieur est compliqué pour l'utilisateur.
      Au contraire ca donne liberté et uniformité d'expression.
     (vous écrivez p 2 "l'utilisateur n'aura à manipuler que des
constructions logiques au premier ordre (ce qui reste raisonnable),...")

      Par ailleurs votre papier ne donne aucun exemple permettant de
juger si cet objectif de simplicité pour l'utilisateur peut être atteint
dans le cadre théorique que vous choisissez.
      Il est naturel pour un ingénieur de prouver qu'un programme
vérifie une assertion (post condition, invariant) ou qu'une relation de
décroissance est bien fondée. Prouver qu'une fonction
      est totale en montrant qu'elle a le bon type ne me parait pas ce
qui a de plus naturel en milieu industriel.

      Ainsi votre papier doit  être apprécié selon l'option 1 (ou alors
vous devez justifier les avantages que vous avancez et pas seulement les
affirmer).
      Il me semble qu'il gagnerait en clareté  à se positionner plus
franchement dans cette perspective.


 <P>Commentaires reserves au comite de programme:<P>

     Ce papier ne me convainc pas. En tant que papier théorique il me
donne l'impression de reprendre des choses bien connues et depuis un
certain temps, mais je ne me considère pas suffisamment
compétent pour être sûr de ne pas être passé à coté d'un réel intérêt
académique.  Je laisse à d'autres membres du comité la responsabilité
d'avoir un avis plus tranché sur la question. Je l'ai classé
acceptable, parce que je ne me sens pas autorisé à le rejeter.

Du point de vue pratique, il me convainc encore moins. Il me semble que
Coq, notoirement absent de la biblio,  répond aux objectifs visés avec
Program et Correctness, dans un cadre plus proche (ou disons moins
éloigné) de l'ingénieur que le cadre AF2.

Donc si personne ne sait défendre la contribution des proposition 5 et 7
de la section 4, ou l'orignalité de la démarche de plongement dans TTR,
je ne vois pas comment justifier la sélection de ce papier.



 </BODY>
 </HTML>